/*
 * BookPickBehavior.java
 *
 * Created on 8. Mai 2003, 15:48
 */

package j3d_uebung.behavior;
import com.sun.j3d.utils.picking.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import javax.media.j3d.Appearance;
import java.awt.Color;
import java.awt.event.MouseEvent;
/**
 *
 * @author  arnd
 */
public class PickBehavior extends Behavior {
    private WakeupCriterion awtEventCondition;
    private PickCanvas pickCanvas;
    private Box object;
    
    /** Aufgabe 4 */
    public PickBehavior(Canvas3D canvas, BranchGroup root, Box object, TransformGroup targetTG) {

        this.object = object;
        
        //Aufwachkriterium auf Mausklick setzen

        
        //PickCanvas mit Canvas und Root-BranchGroup erzeugem
        pickCanvas = new PickCanvas(canvas, root);
        //PickCanvas auf BOUNDS-Modus setzen
        pickCanvas.setMode(PickTool.BOUNDS);
        //Punktgenaues Picking setzen (keine Toleranz)
        pickCanvas.setTolerance(0.0f);
       
        //neues OpenBehavior erzeugen 

        
        //neues CloseBehavior erzeugen

        
        //Behaviorpartner fr Open- und CloseBehavior setzen
        
        //Scheduling Bounds fr alle 3 Behaviors setzen
        
        //neue Behaviors zum ffnen, Schlieen zur Wurzelgruppe hinzufgen
    }
    
    public void initialize() {
        //Aufwachkriterium setzen
        

    }
  
    public void processStimulus(java.util.Enumeration enumeration) {
        //Kriterium erfllt?
        if (awtEventCondition.hasTriggered()) {
            //angeklicktes Objekt holen
            WakeupOnAWTEvent cond = (WakeupOnAWTEvent)enumeration.nextElement();
            MouseEvent me = (MouseEvent)cond.getAWTEvent()[0];
            pickCanvas.setShapeLocation(me);
            PickResult result = pickCanvas.pickClosest();
            
            //Wenn Objekt Vorder- oder Rckseite des Frontcovers war, Open- und CloseBehavior benachrichtigen
            if ((result!=null)&&((object.getShape(Box.FRONT) == result.getObject())||(object.getShape(Box.BACK) == result.getObject()))) {
                this.postId(7);
            }

        }
        
        //Beim nchsten Klick wieder aufwachen
        this.wakeupOn(awtEventCondition);
    }
}
